@use '../core/placeholders/input';

label {
  display: flex;
  align-items: center;
  cursor: pointer;
  font-size: var(--font-size-small);
  gap: var(--spacer-default);
  text-align: left;

  > input {
    flex: none;
  }
}

select {
  padding-right: 1.5rem; // Compensate for the arrow space
  appearance: none;
  background-image: var(--form-select-arrow);
  background-position-x: right var(--spacer-small);
  background-position-y: center;
  background-repeat:  no-repeat;
  background-size: 1rem 1rem;
  color: var(--input-color);
  overflow-x: hidden;
  text-overflow: ellipsis;
}

select,
input[type='date'],
input[type='datetime-local'],
input[type='email'],
input[type='hidden'],
input[type='image'],
input[type='month'],
input[type='number'],
input[type='password'],
input[type='search'],
input[type='tel'],
input[type='text'],
input[type='time'],
input[type='url'],
input[type='week'] {
  @extend %input;

  height: var(--input-height);
}

textarea {
  @extend %input;
}

input[type='checkbox'],
input[type='radio'] {
  border-radius: var(--border-radius-small);
  appearance: none;
  background-color: var(--background-color-alt);
  background-position: center;
  background-repeat: no-repeat;
  background-size: 0 0;
  box-shadow: inset 0 0 0 1px var(--foreground-color);
  cursor: pointer;
  outline: 0;
  transition: background-size 0.15s;
  vertical-align: text-bottom;
}

input[type='checkbox'] {
  width: 1rem;
  height: 1rem;
  background-image: var(--form-checkbox-background);

  &:checked {
    background-size: 60% 60%;
  }
}

input[type='radio'] {
  width: 0.85rem;
  height: 0.85rem;
  border-radius: 50%;
  background-image: var(--form-radio-background);

  &:checked {
    background-size: 70% 70%;
  }
}

input[type="range"] {
  all:revert;
  width: 100%;
  height: 1rem;
}

input[type='color'] {
  all:revert;
  width: var(--spacer-large);
  height: min(var(--input-height), 100%);
  padding: 0;
  border:none;

  // Not optimal, but at least it shows on WebKit
  &::-webkit-color-swatch-wrapper {
    height: 1.2rem;
    padding: 0;
  }
}

fieldset {
  padding: var(--spacer-default);
  background-color: var(--component-content-background-alt)
}

legend {
  padding: var(--spacer-tiny) var(--spacer-default);
  border-radius: var(--border-radius-small);
  background-color: var(--component-content-background-alt);

  // Fix margin on included fields
  & + .rui-field:not(:first-child) {
    margin-top: 0;
  }
}
